
// PMoveDlg.cpp: 实现文件
//

#include "pch.h"
#include "framework.h"
#include "定长运动.h"
#include "PMoveDlg.h"
#include "afxdialogex.h"
#include"MC_dll.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// 用于应用程序“关于”菜单项的 CAboutDlg 对话框

class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();

// 对话框数据
#ifdef AFX_DESIGN_TIME
	enum { IDD = IDD_ABOUTBOX };
#endif

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV 支持

// 实现
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(IDD_ABOUTBOX)
{

}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CPMoveDlg 对话框



CPMoveDlg::CPMoveDlg(CWnd* pParent /*=nullptr*/)
	: CDialogEx(IDD_MY_DIALOG, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	startVel = 500;
	maxVel = 2000;
	stopVel = 500;
	tAcc = 0.1;
	tDec = 0.1;
	sRatio = 0;
	maxAcc = 1000000;
	pos = 10000;
}

void CPMoveDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_EDIT1, startVel);
	DDX_Text(pDX, IDC_EDIT2, maxVel);
	DDX_Text(pDX, IDC_EDIT3, stopVel);
	DDX_Text(pDX, IDC_EDIT4, tAcc);
	DDX_Text(pDX, IDC_EDIT5, tDec);
	DDX_Text(pDX, IDC_EDIT6, sRatio);
	DDX_Text(pDX, IDC_EDIT7, maxAcc);
	DDX_Text(pDX, IDC_EDIT8, pos);
	DDX_Control(pDX, IDC_COMBO1, axisNoCombobox);
	DDX_Control(pDX, IDC_EDIT12, newSpeedUpdateOnline);
	DDX_Control(pDX, IDC_EDIT13, newPosUpdateOnline);
}

BEGIN_MESSAGE_MAP(CPMoveDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON5, &CPMoveDlg::OnBnClickedButton5)
	ON_BN_CLICKED(IDC_BUTTON6, &CPMoveDlg::OnBnClickedButton6)
	ON_BN_CLICKED(IDC_BUTTON4, &CPMoveDlg::OnBnClickedButton4)
	ON_BN_CLICKED(IDC_BUTTON1, &CPMoveDlg::OnBnClickedButton1)
	ON_BN_CLICKED(IDC_BUTTON2, &CPMoveDlg::OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, &CPMoveDlg::OnBnClickedButton3)
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CPMoveDlg 消息处理程序

BOOL CPMoveDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// 将“关于...”菜单项添加到系统菜单中。

	// IDM_ABOUTBOX 必须在系统命令范围内。
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != nullptr)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// 设置此对话框的图标。  当应用程序主窗口不是对话框时，框架将自动
	//  执行此操作
	SetIcon(m_hIcon, TRUE);			// 设置大图标
	SetIcon(m_hIcon, FALSE);		// 设置小图标

	// TODO: 在此添加额外的初始化代码
#pragma region 开卡
	WORD pciNum = 0; //用于接收开卡成功的卡数
	WORD pcieIndex[12];
	DWORD functionReturn = 0; //函数返回值
	functionReturn = MC_Open(0, CONNECTION_PCI, "", &pciNum, pcieIndex);
	if (functionReturn == 0)//函数成功执行
	{
		if (pciNum > 0)//至少一张卡被成功开卡
		{
			cardConnectNo = pcieIndex[0]; //如果有多卡的情况下这里也只用卡1演示

#pragma region 获取卡信息
			//--------------------------获取卡信息------------------------------------------------------------------------
			WORD totalAxisNum = 0; //用于获取卡的轴数
			WORD linerNum = 0;//用于获取卡的插补系个数
			WORD totalInNum = 0;//用于获取卡的输入口数量
			WORD totalOutNum = 0;//用于获取卡的输出口数量
			WORD totalPWMNum = 0;//用于获取卡的PWM通道数量
			functionReturn = MC_GetTotalAxesAndIONum(cardConnectNo, &totalAxisNum, &linerNum, &totalInNum, &totalOutNum,&totalPWMNum);
			for (int axisNo = 0; axisNo < totalAxisNum; axisNo++)
			{
				CString str;
				str.Format(_T("%d"), axisNo);
				axisNoCombobox.AddString(str);
			}
			axisNoCombobox.SetCurSel(0);//设置轴号ComboBox默认选择

			//------------------------------------------------------------------------------------------------------------
#pragma endregion
			SetTimer(1, 200, NULL);//启动界面监控定时器

		}
		else
		{
			MessageBox(L"未找到卡!");
		}
	}
	else
	{
		MessageBox(L"开卡失败!");
	}

	newSpeedUpdateOnline.SetWindowTextW(L"3000");
	newPosUpdateOnline.SetWindowTextW(L"20000");
#pragma endregion

	return TRUE;  // 除非将焦点设置到控件，否则返回 TRUE
}

void CPMoveDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

// 如果向对话框添加最小化按钮，则需要下面的代码
//  来绘制该图标。  对于使用文档/视图模型的 MFC 应用程序，
//  这将由框架自动完成。

void CPMoveDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // 用于绘制的设备上下文

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// 使图标在工作区矩形中居中
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// 绘制图标
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

//当用户拖动最小化窗口时系统调用此函数取得光标
//显示。
HCURSOR CPMoveDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


/// <summary>
/// 执行运动按钮点击执行的程序
/// </summary>
void CPMoveDlg::OnBnClickedButton5()
{
	// TODO: 在此添加控件通知处理程序代码
	UpdateData(true); //用于将屏幕上控件中的数据交换到变量中

	WORD axisNo = axisNoCombobox.GetCurSel(); //需要运动的轴号

	MC_Power(cardConnectNo, axisNo, 1); //轴使能，轴使能之后才能够通过指令启动运动发出脉冲

	const int MovePosFunction = 0;
	switch (MovePosFunction)//启动一段点位运动有三种写法
	{
	case 0:
		//先设置轴的运动参数
		MC_SetAxisMotionPrm(cardConnectNo, axisNo, startVel, maxVel, stopVel, tAcc, tDec, sRatio, maxAcc);

		//启动运动
		//参数三，pos_mode = 0时为相对运动模式， = 1时为绝对运动模式
		MC_MovePos(cardConnectNo, axisNo, 0, pos);
		break;
	case 1:
		//启动一段绝对位置运动，只需要一条指令
		MC_MoveAbsolute(cardConnectNo, axisNo, pos, startVel, stopVel, maxVel, tAcc, tDec, sRatio, maxAcc);
		break;
	case 2:
		//启动一段相对位置运动，只需要一条指令
		MC_MoveRelative(cardConnectNo, axisNo, pos, startVel, stopVel, maxVel, tAcc, tDec, sRatio, maxAcc);
		break;
	default:
		break;
	}

	UpdateData(false);//用于将数据在屏幕中对应控件中显示出来
}

/// <summary>
/// 停止运动按钮点击执行的代码
/// </summary>
void CPMoveDlg::OnBnClickedButton6()
{
	// TODO: 在此添加控件通知处理程序代码
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号

	//参数三，stop_mode = 0时停止模式为减速停止，=1时为立即停止
	//参数四，stop_time为减速停止时的减速时间
	MC_StopAxis(cardConnectNo, axisNo, 0, 0.1);
}

/// <summary>
/// 紧急停止按钮点击执行的代码
/// </summary>
void CPMoveDlg::OnBnClickedButton4()
{
	// TODO: 在此添加控件通知处理程序代码
	MC_StopEmgImd(cardConnectNo); //急停函数，所有轴立即停止
}

/// <summary>
/// 位置清除按钮点击执行的代码
/// </summary>
void CPMoveDlg::OnBnClickedButton1()
{
	// TODO: 在此添加控件通知处理程序代码
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	MC_SetAxisCmdPos(cardConnectNo, axisNo, 0);//指令位置清零
}

/// <summary>
/// 在线变速按钮点击执行的代码
/// </summary>
void CPMoveDlg::OnBnClickedButton2()
{
	// TODO: 在此添加控件通知处理程序代码
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	double newVel = 0;
	CString str1;
	newSpeedUpdateOnline.GetWindowTextW(str1);
	newVel = _tstof(str1); //改变速度
	MC_MoveUpdateVel(cardConnectNo, axisNo, newVel);
}

/// <summary>
/// 在线变位按钮点击执行的代码
/// </summary>
void CPMoveDlg::OnBnClickedButton3()
{
	// TODO: 在此添加控件通知处理程序代码
	//在运动过程中想要改变最终停止的位置，只需要再次执行一次点动指令发送新位置就可以了
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	double newPos = 0;
	CString str1;
	newPosUpdateOnline.GetWindowTextW(str1);
	newPos = _tstof(str1); //新目标位置
	MC_MovePos(cardConnectNo, axisNo, 0, newPos);
}


void CPMoveDlg::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: 在此添加消息处理程序代码和/或调用默认值
	WORD axisNo = axisNoCombobox.GetCurSel();//轴号
	double cmdPos = 0;
	MC_GetAxisCmdPos(cardConnectNo, axisNo, &cmdPos);//获取当前指令位置
	CString cmdPosStr;
	cmdPosStr.Format(_T("%f"), cmdPos);
	GetDlgItem(IDC_EDIT10)->SetWindowTextW(cmdPosStr); //设置到界面

	double cmdSpeed = 0;
	MC_GetAxisCmdSpeed(cardConnectNo, axisNo, &cmdSpeed); //获取当前指令速度
	CString cmdSpeedStr;
	cmdSpeedStr.Format(_T("%f"), cmdSpeed);
	GetDlgItem(IDC_EDIT9)->SetWindowTextW(cmdSpeedStr); //设置到界面

	WORD checkDone = 1;
	MC_GetAxisCheckDone(cardConnectNo, axisNo, &checkDone);//获取轴运动状态
	switch (checkDone)
	{
	case 0:
		GetDlgItem(IDC_EDIT11)->SetWindowTextW(L"运动中");
		break;
	case 1:
		GetDlgItem(IDC_EDIT11)->SetWindowTextW(L"空闲");
		break;
	default:
		CString checkDoneStr;
		checkDoneStr.Format(_T("%d"), checkDone);
		GetDlgItem(IDC_EDIT11)->SetWindowTextW(checkDoneStr);
		break;
	}

	CDialogEx::OnTimer(nIDEvent);
}

/// <summary>
/// 窗体销毁时发生
/// </summary>
void CPMoveDlg::OnDestroy()
{
	KillTimer(1);
	MC_Close(cardConnectNo); //关卡释放资源
	CDialogEx::OnDestroy();

	// TODO: 在此处添加消息处理程序代码
}
